/* sysprof-dbus-monitor.h
 *
 * Copyright 2023 Christian Hergert <chergert@redhat.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#pragma once

#include "sysprof-instrument.h"

G_BEGIN_DECLS

#define SYSPROF_TYPE_DBUS_MONITOR         (sysprof_dbus_monitor_get_type())
#define SYSPROF_IS_DBUS_MONITOR(obj)      G_TYPE_CHECK_INSTANCE_TYPE(obj, SYSPROF_TYPE_DBUS_MONITOR)
#define SYSPROF_DBUS_MONITOR(obj)         G_TYPE_CHECK_INSTANCE_CAST(obj, SYSPROF_TYPE_DBUS_MONITOR, SysprofDBusMonitor)
#define SYSPROF_DBUS_MONITOR_CLASS(klass) G_TYPE_CHECK_CLASS_CAST(klass, SYSPROF_TYPE_DBUS_MONITOR, SysprofDBusMonitorClass)

typedef struct _SysprofDBusMonitor      SysprofDBusMonitor;
typedef struct _SysprofDBusMonitorClass SysprofDBusMonitorClass;

SYSPROF_AVAILABLE_IN_ALL
GType              sysprof_dbus_monitor_get_type            (void) G_GNUC_CONST;
SYSPROF_AVAILABLE_IN_ALL
SysprofInstrument *sysprof_dbus_monitor_new                 (GBusType            bus_type);
SYSPROF_AVAILABLE_IN_ALL
SysprofInstrument *sysprof_dbus_monitor_new_for_bus_address (const char         *bus_address);
SYSPROF_AVAILABLE_IN_ALL
GBusType           sysprof_dbus_monitor_get_bus_type        (SysprofDBusMonitor *self);
SYSPROF_AVAILABLE_IN_ALL
const char        *sysprof_dbus_monitor_get_bus_address     (SysprofDBusMonitor *self);

G_DEFINE_AUTOPTR_CLEANUP_FUNC (SysprofDBusMonitor, g_object_unref)

G_END_DECLS
